<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../common/meta';
import {
  RecognitionSpotlight,
  TabbedCaseStudies,
  TabbedFeatures,
} from '../components/home/index.vue';
import { NextStepAlt } from '~/components/common/index.vue';

export default Vue.extend({
  components: {
    NextStepAlt,
    RecognitionSpotlight,
    TabbedCaseStudies,
    TabbedFeatures,
  },
  nuxtI18n: false,
  async asyncData({ $content }: any) {
    try {
      const doc = await $content('en-us/lp').fetch();

      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  head() {
    return getPageMetadata(
      {
        ...this.doc,
        noIndex: true,
      },
      this.$route.path,
    );
  },
});
</script>

<template>
  <div class="homepage">
    <section id="into-section" class="intro">
      <div class="intro-content slp-container">
        <div class="hero__item">
          <div id="hero-copy" class="hero__content-block">
            <SlpTypography tag="h1" variant="heading2-bold">
              {{ doc.intro_block.title }}
            </SlpTypography>
            <SlpTypography tag="h2" variant="body1" class="slp-my-16">
              {{ doc.intro_block.blurb }}
            </SlpTypography>
            <SlpButton
              id="hero-copy-button"
              :variant="doc.intro_block.primary_button.variant"
              :href="doc.intro_block.primary_button.href"
              :data-ga-name="doc.intro_block.primary_button.data_ga_name"
              :data-ga-location="
                doc.intro_block.primary_button.data_ga_location
              "
              class="slp-mt-24"
            >
              {{ doc.intro_block.primary_button.text }}
            </SlpButton>
          </div>
        </div>
        <div class="hero__item">
          <div id="hero-card" class="hero-card">
            <img
              :src="doc.intro_block.card.img_src"
              :alt="doc.intro_block.card.img_alt"
              class="slp-mb-16 hero-card__image"
              preload
            />
            <SlpTypography
              id="hero-card-content"
              tag="h2"
              variant="heading5-bold"
              class="hero-card__blurb slp-mb-16"
            >
              {{ doc.intro_block.card.blurb }}
            </SlpTypography>
            <SlpButton
              id="hero-card-button"
              :href="doc.intro_block.card.button.href"
              :variant="doc.intro_block.card.button.variant"
              :data-ga-name="doc.intro_block.card.button.data_ga_name"
              :data-ga-location="doc.intro_block.card.button.data_ga_location"
              class="slp-mt-32"
            >
              {{ doc.intro_block.card.button.text }}
              <SlpIcon name="chevron-right" variant="product" size="medium" />
            </SlpButton>
          </div>
        </div>
      </div>
    </section>

    <section class="customers slp-container">
      <div class="customer-logos">
        <a
          href="http://about.gitlab.com/customers/"
          class="customer-logos__link customer-logos__link--title"
        >
          Trusted By:
        </a>
        <a
          v-for="logo in doc.personalized_customer_logos.showcased_enterprises"
          :key="logo.alt"
          :href="logo.url"
          :data-ga-name="logo.alt"
          data-ga-location="body"
          :aria-label="logo.link_label ? logo.link_label : null"
          class="customer-logos__link"
          :class="[logo.size ? logo.size : '']"
        >
          <img
            :src="logo.image_url"
            :alt="logo.alt"
            class="customer-logos__company-icon"
            preload
          />
        </a>
      </div>
    </section>

    <div class="features__heading slp-container">
      <SlpTypography id="features-heading" tag="h2" variant="heading5-bold">
        {{ doc.blurb_grid.title }}
      </SlpTypography>
    </div>
    <section class="features slp-container">
      <div
        v-for="feature in doc.blurb_grid.features"
        :id="feature.id"
        :key="feature.id"
        class="feature-card"
      >
        <SlpIcon
          class="slp-mr-8 slp-mb-8"
          :size="feature.icon.size"
          :name="feature.icon.name"
          :variant="feature.icon.variant"
        />
        <SlpTypography tag="h3" variant="heading5-bold">
          {{ feature.title }}
        </SlpTypography>
        <SlpTypography
          tag="div"
          variant="body2"
          class="slp-mt-8"
          v-html="feature.blurb"
        />
      </div>
    </section>

    <section class="featured-showcase slp-container">
      <div class="featured-showcase__left">
        <div class="featured-showcase__card">
          <SlpIcon
            :size="doc.feature_showcase.icon.size"
            :name="doc.feature_showcase.icon.name"
            :variant="doc.feature_showcase.icon.variant"
            class="slp-mb-16"
          />
          <SlpTypography
            tag="div"
            variant="heading5-bold"
            class="slp-mb-16"
            v-html="doc.feature_showcase.blurb"
          />
          <div class="slp-mb-16">
            <div
              v-for="stats in doc.feature_showcase.stats"
              :id="stats.id"
              :key="stats.id"
              class="featured-showcase__pill"
            >
              <SlpTypography tag="h3" variant="heading5-bold" class="slp-mr-8">
                {{ stats.value }}
              </SlpTypography>
              <SlpTypography tag="p" variant="body3-bold">
                {{ stats.blurb }}
              </SlpTypography>
            </div>
          </div>
          <SlpButton
            :variant="doc.feature_showcase.button.variant"
            :href="doc.feature_showcase.button.href"
            :data-ga-name="doc.feature_showcase.button.data_ga_name"
            :data-ga-location="doc.feature_showcase.button.data_ga_body"
            class="feature-showcase__btn"
          >
            {{ doc.feature_showcase.button.text }}
            <SlpIcon name="chevron-right" variant="product" size="medium" />
          </SlpButton>
        </div>
      </div>
      <div class="featured-showcase__right">
        <div class="featured-showcase__right-top">
          <SlpIcon
            :size="doc.feature_showcase.roi.icon.size"
            :name="doc.feature_showcase.roi.icon.name"
            :variant="doc.feature_showcase.roi.icon.variant"
            class="slp-mb-16"
          />
          <SlpTypography tag="p" variant="body1-bold" class="slp-mb-16">
            {{ doc.feature_showcase.roi.title }}
          </SlpTypography>
          <SlpButton
            :href="doc.feature_showcase.roi.button.href"
            :variant="doc.feature_showcase.roi.button.variant"
            :data-ga-name="doc.feature_showcase.roi.button.data_ga_name"
            :data-ga-location="doc.feature_showcase.roi.button.data_ga_location"
            class="feature-showcase__btn"
          >
            {{ doc.feature_showcase.roi.button.text }}
            <SlpIcon name="chevron-right" variant="product" size="medium" />
          </SlpButton>
        </div>
        <div class="featured-showcase__right-bottom">
          <SlpIcon
            :size="doc.feature_showcase.explore.icon.size"
            :name="doc.feature_showcase.explore.icon.name"
            :variant="doc.feature_showcase.explore.icon.variant"
            class="slp-mb-16"
          />
          <SlpTypography tag="p" variant="body1-bold" class="slp-mb-16">
            {{ doc.feature_showcase.explore.title }}
          </SlpTypography>
          <SlpButton
            :href="doc.feature_showcase.explore.button.href"
            :variant="doc.feature_showcase.explore.button.variant"
            :data-ga-name="doc.feature_showcase.explore.button.data_ga_name"
            :data-ga-location="
              doc.feature_showcase.explore.button.data_ga_location
            "
            class="feature-showcase__btn"
          >
            {{ doc.feature_showcase.explore.button.text }}
            <SlpIcon name="chevron-right" variant="product" size="medium" />
          </SlpButton>
        </div>
      </div>
    </section>

    <TabbedFeatures v-if="doc.tabbed_features" :data="doc.tabbed_features" />
    <TabbedCaseStudies v-bind="doc.personalized_tabbed_case_studies[0]" />
    <RecognitionSpotlight
      v-if="doc.recognition_spotlight"
      :data="doc.recognition_spotlight"
    />

    <NextStepAlt />
  </div>
</template>

<style scoped lang="scss">
$md-width-max: 740px;

.homepage {
  --color-primary: #171321;
  --color-accent: #7759c2;
  --color-light: #fff;
  --space-sm: 8px;
  --space-md: 16px;
  --space-lg: 32px;

  display: flex;
  align-items: center;
  flex-direction: column;
  width: 100%;
}

h1 {
  font-size: 40px;
  font-weight: 600;
  letter-spacing: -1px;
  line-height: 48px;
}

.slp-container {
  display: flex;
  width: 100%;
  padding: 0 16px;

  @media (min-width: 640px) {
    max-width: 95%;
  }
  @media (min-width: 1024px) {
    max-width: 1024px;
  }
  @media (min-width: 1170px) {
    max-width: 1170px;
  }
}

.hero {
  &__item {
    margin-right: 40px;

    &-wrapper {
      height: 100%;
    }
    &--image img {
      -o-object-fit: cover;
      object-fit: cover;
      width: 100%;
    }

    @media (max-width: $md-width-max) {
      margin-right: 0;
    }
  }
  &__content {
    &-block {
      margin-top: 64px;
      width: 460px;
      margin-right: 40px;

      @media (max-width: $md-width-max) {
        width: 100%;
        margin-right: 0;
        margin-bottom: 16px;
      }
    }
  }
  &-card {
    background: linear-gradient(
      176deg,
      hsla(0, 0%, 100%, 0.75),
      hsla(0, 0%, 100%, 0.4)
    );
    border-radius: 9px;
    display: flex;
    flex-direction: column;
    height: 100%;
    margin-right: 40px;
    max-width: 460px;
    overflow: hidden;
    padding: 24px;
    width: 100%;

    &__image {
      aspect-ratio: 4/2.5;
      border-radius: 8px;
      max-height: 260px;
      -o-object-fit: cover;
      object-fit: cover;
      -o-object-position: top;
      object-position: top;
      width: 100%;
    }
    &__blurb {
      color: #171321;
      padding: 24px 0 0;
    }
    &__button {
      color: #7759c2;
      margin: auto 0 0;
    }
    &__content-block {
      margin-top: 64px;
      width: 100%;
    }

    @media (max-width: $md-width-max) {
      margin-right: 0;
    }
  }
}

.intro {
  padding: var(--space-lg) 0 90px;
  position: relative;
  width: 100%;
  display: flex;
  justify-content: center;

  &:after {
    position: absolute;
    background: url(/nuxt-images/home/gradient.png);
    background-position: 100% 0;
    background-size: 100% 1400px;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    content: '';
    z-index: -2;

    @media (max-width: $md-width-max) {
      background-position: top;
      background-size: 300% 1400px;
    }
  }

  &:before {
    position: absolute;
    bottom: 0;
    left: 0;
    right: 0;
    content: '';
    height: 125px;
    z-index: -1;
    background: linear-gradient(0deg, #fff, #fff 24.59%, hsla(0, 0%, 100%, 0));
  }

  &-content {
    flex: 1;
    display: flex;
    justify-content: center;

    @media (max-width: $md-width-max) {
      flex-direction: column;
    }
  }
}

.customers {
  width: 100%;
  margin-bottom: 112px;

  @media (max-width: $md-width-max) {
    margin-bottom: 80px;
  }
}

.customer-logos {
  display: flex;
  justify-content: space-between;
  align-items: center;
  flex-wrap: wrap;
  width: 100%;

  a:first-of-type {
    justify-content: flex-start;
  }

  &__link {
    display: flex;
    width: 110px;
    justify-content: center;
    color: var(--color-primary);
    font-size: 16px;
    font-weight: 400;
    line-height: 24px;

    &.lg {
      width: 170px;
    }
    &.sm {
      width: 90px;
    }

    &--title {
      @media (max-width: $md-width-max) {
        width: 100%;
      }
    }

    @media (max-width: $md-width-max) {
      margin-bottom: 32px;
    }
  }

  img {
    max-width: 100%;
    filter: grayscale(100%);
  }
}

.features {
  flex-direction: row;
  margin: 0 0 160px 0;

  @media (max-width: $md-width-max) {
    flex-direction: column;
    margin: 0 0 112px 0;
  }

  &__heading {
    margin: 64px 0 16px 0;
    display: flex;
    align-content: flex-start;
  }
}

.feature {
  &-grid {
    display: grid;
    grid-template-columns: repeat(auto-fit, minmax(250px, 1fr));
    grid-gap: var(--space-lg);
    margin: var(--space-lg) 0;
  }

  &-card {
    border: 1px solid #e8e7eb;
    border-radius: 8px;
    padding: 24px;
    margin-right: 32px;
    display: flex;
    flex-basis: 0;
    flex-grow: 1;
    width: 100%;
    flex-direction: column;

    @media (max-width: $md-width-max) {
      margin-bottom: 32px;
    }
  }
}

.featured-showcase {
  display: flex;
  position: relative;
  margin-bottom: -96px;

  &__pill {
    align-items: center;
    background: #fff;
    border-radius: 90px;
    display: flex;
    margin-top: 16px;
    padding: 8px 24px;
  }

  &__left {
    background-color: #f6f3fe;
    margin-right: 16px;
    padding: 32px;
    border-radius: 8px 0 0 8px;
    width: 100%;
  }

  &__right {
    width: 100%;
    &-top {
      background-color: #f6f3fe;
      padding: 32px;

      @media (max-width: $md-width-max) {
        margin-top: 16px;
      }
    }
    &-bottom {
      background-color: #f6f3fe;
      padding: 32px;
      margin-top: 16px;
      border-radius: 0 0 90px 0;
    }
  }

  @media (max-width: $md-width-max) {
    flex-direction: column;
  }
}

.tabbed-features,
.recognition-spotlight,
.next-step-alt {
  width: 100%;
  display: flex;
}

.tabbed-features {
  background: var(--color-primary);
  color: var(--color-light);
  padding: var(--space-lg) 0;
  padding-top: 210px !important;
}

.tab {
  display: flex;
  margin: var(--space-lg) 0;

  &-tab {
    display: block;
  }

  &-buttons {
    background: var(--color-accent);
    padding: var(--space-md);
    border-radius: 90px;
  }
}

.recognition-spotlight {
  padding: 64px 0 0 !important;
}
</style>
